/*
  clock.c - part of USBasp

  Autor..........: Thomas Fischl <tfischl@gmx.de> 
  Description....: Provides functions for timing/waiting
  Licence........: Free under certain conditions. See Documentation.
  Creation Date..: 2005-02-23
  Last change....: 2005-04-20
*/

#include <inttypes.h>
#include <avr/io.h>
#include "clock.h"

/* wait time * 320 us */
#if 0
/* original */
void clockWait(uint8_t time) {
  
  uint8_t i;
  for (i = 0; i < time; i++) {
    uint8_t starttime = TIMERVALUE;
    while ((uint8_t) (TIMERVALUE - starttime) < CLOCK_T_320us) {}	
  }
}
#endif
/*
 * 2006-05-06 by t.kuroki
 */
#if 0
void clockWait(uint8_t time)
{
	uint8_t starttime = TIMERVALUE;
	while (time)
	{
		do {} while ((uint8_t)(TIMERVALUE - starttime) < CLOCK_T_320us);
		starttime += CLOCK_T_320us;
		--time;
	}
}
#endif

void delay_10us(uint8_t cnt)
{
	uint8_t starttime = TIMERVALUE2;
	do
	{
		do {} while ((uint8_t)(TIMERVALUE2 - starttime) < CLOCK_T_10us);
		starttime += CLOCK_T_10us;
	} while (--cnt);
}

void delay_100us(uint8_t cnt)
{
	uint8_t starttime = TIMERVALUE2;
	do
	{
		uint8_t mk100us = 10;
		do
		{
			do {} while ((uint8_t)(TIMERVALUE2 - starttime) < CLOCK_T_10us);
			starttime += CLOCK_T_10us;
		} while (--mk100us);
	} while (--cnt);
}

#if 0
void delay_ms(uint8_t cnt)
{
	uint8_t starttime = TIMERVALUE2;
	do
	{
		uint8_t mk1ms = 100;
		do
		{
			do {} while ((uint8_t)(TIMERVALUE2 - starttime) < CLOCK_T_10us);
			starttime += CLOCK_T_10us;
		} while (--mk1ms);
	} while (--cnt);
}
#endif
