/*
  clock.h - part of USBasp

  Autor..........: Thomas Fischl <tfischl@gmx.de> 
  Description....: Provides functions for timing/waiting
  Licence........: Free under certain conditions. See Documentation.
  Creation Date..: 2005-02-23
  Last change....: 2005-04-20
*/
/*
 * 2006-05-06 Target ATMega48/ATMega88/ATMega168 modfied by t.kuroki
 */

#ifndef __clock_h_included__
#define	__clock_h_included__

#ifndef F_CPU
 #define F_CPU          12000000L   /* 12MHz */
#endif

#define TIMERVALUE		TCNT0
#define CLOCK_T_320us	60			// prescaler 1/64

#define TIMERVALUE2		TCNT2		//@@+ by t.k
#define CLOCK_T_10us	(12*10)		// prescaler 1/1

/* set timer0 prescaler to 64 */
/* set timer2 prescaler to 1 */
/* 12MHz/64 187.5KHz=5.33us */
#if defined(__AVR_AT90S2313__) || defined(__AVR_ATmega8__)
  #define clockInit()	{	\
  	TCCR0 = (1 << CS01) | (1 << CS00);	\
  	TCCR2 = (1 << CS20);	\
  }
#elif defined(__AVR_ATmega48__) || defined(__AVR_ATmega88__) \
  ||  defined(__AVR_ATmega168__) || defined(__AVR_ATtiny2313__)
  #define clockInit()	{	\
  	TCCR0B = (1 << CS01) | (1 << CS00);	\
  	TCCR2B = (1 << CS20);	\
  }
#endif
/* wait time * 320 us */
void clockWait(uint8_t time);

//@@+ by t.k
void delay_10us(uint8_t cnt);
void delay_100us(uint8_t cnt);
void delay_ms(uint8_t cnt);

#endif /* __clock_h_included__ */
